  ' XMS-sorting interface by Vincent Voois
  ' This little program demonstrates sorting of various textlines from a
  ' texfile loaded into XMS memory.
  ' Note that you need the object file which handles the XMSroutines of Robin
  ' Duffy (Sequential Software Inc.) somewhere on the ABC-packages.
  '
 
  DEFINT A-Z
 
  REM $INCLUDE: 'SidDeclr.inc'
  REM $INCLUDE: 'XmsVals.inc'
  REM $INCLUDE: 'IsWin.inc'
  REM $INCLUDE: 'Sidbase.bi'

  CLEAR

  CLS

  CALL InitXMS(Status%, MemSize&)

  FreeHandles 'Clear all (possible) open handles:
              'when interrupting testprocedures, you're memory can get clogged
              'up with previous test-data,closing XMS-handle pointers is must!

  ' Open file, count the lines included and measure the linelengths

  PRINT "Checking input data..."

  OPEN "text.tst" FOR INPUT AS #1 'or Any file with some textlines in it

  DO WHILE NOT EOF(1)
    LINE INPUT #1, A$

    FileLines& = FileLines& + 1

    IF LEN(A$) > Leng% THEN
      Leng% = LEN(A$)
    END IF

  LOOP

  Leng% = Leng% + 1

  CLOSE

  'The memory to allocate will be all filelines multiplied by the longest line
  'it's length, devided by 1024 and added 1K for insurance.
 
  TotalFileSize% = ((FileLines& * Leng%) \ 1024) + 1

  'Calculate statistics
 
  MustMem& = TotalFileSize%
 
  MustMem& = MustMem& * 1024
 
  PRINT "Allocating memory:"; MustMem&; "Bytes"

  'Fill Filehandle
 
  FileHandle% = GetXMS(TotalFileSize%)

  ' Open up file again and fill up XMS memory with the contents, do check on
  ' errors during xms-transfers

  OPEN "text.tst" FOR INPUT AS #1

  DO WHILE NOT EOF(1)
    LINE INPUT #1, In$

    LineNumber& = LineNumber& + 1
   
    PutReeks In$, LineNumber&

    IF XMSError THEN
      FreeHandles

      PRINT LineNumber&

      ShowXmsError TempError%

      CLOSE

      Terminate
    END IF

  LOOP

  'Sorting the stuphz in XMS through basic...

  PRINT "Sorting "; FileLines&; "Elements...."

  HuthSort
 
  ' And show the sorted stuphz
 
  FOR i& = 1 TO LineNumber&
    PRINT ">"; GetReeks$(i&); "<"

    IF NonStop% = 0 THEN

      DO
        T$ = INKEY$
      LOOP UNTIL T$ <> ""

      IF T$ = "n" THEN
        NonStop% = 1
      END IF

      IF T$ = CHR$(27) THEN
        FreeHandles

        PRINT "Aborting..."

        END
      END IF

    END IF

  NEXT i&

  FreeHandles

SUB CheckXMs
 
  CLS

  CALL InitXMS(Status%, MemSize&)
 
  IF Status% THEN
   
    IF MemSize& < 4096 THEN
     
      IF OsMode% < 4 THEN
        PRINT "Warning, low XMS memory detected!"
       
        IF MemSize& < 2048 THEN
          PRINT "You need at least 2MB XMS memory!"
         
          PRINT "Exitting."
        END IF
      ELSE
        PRINT "XMS detected..."
       
        TestHandle% = GetXMS(2048)
       
        IF WhichXError% > 0 THEN
          TempError% = WhichXError%
         
          ShowXmsError TempError%
        END IF
       
        CALL FreeXMS(TestHandle%)
      END IF
   
    ELSE
      PRINT "XMS detected..."
     
      TestHandle% = GetXMS(2048)
      
      IF WhichXError% > 0 THEN
        TempError% = WhichXError%
       
        ShowXmsError TempError%
      END IF
      
      CALL FreeXMS(TestHandle%)
    END IF
 
  ELSE
    PRINT "Error, no XMS memory detected"
   
    PRINT "Exitting."
 
    END
  END IF

END SUB

SUB FreeHandles
 
  ' This routine is clearing various XMS handles, i just did it to be capable
  ' to interrupt basic routines while testing them without clogging up memory
  ' with reults of previous tests.

 
  CALL FreeXMS(DbaseHandle%)
  CALL FreeXMS(FileHandle%)
  
END SUB

FUNCTION GetReeks$ (Nummer&)
 
  ' This routine substitutes the [Array()] handlers of Quickbasic
  ' It get's an element out of XMS-memory and then stores it into a string
  ' value.

  SELECT CASE TempHandler%
   
    CASE IS = 1
      File(1).FileLine = STRING$(Leng%, " ")
 
      CALL XGetElement(FileHandle%, File(1), Leng%, Nummer&)
 
      GetReeks$ = RTRIM$(File(1).FileLine)
   
    CASE IS = 2
      Dbase(1).DbaseLine = STRING$(Leng%, " ")

      CALL XGetElement(DbaseHandle%, Dbase(1), 102, Nummer&)

      GetReeks$ = RTRIM$(Dbase(1).DbaseLine)
 
    CASE ELSE
      PRINT "XMs handler not set!"
    
      END

  END SELECT
 
END FUNCTION

SUB HuthSort

DIM Compare$

LOCATE CSRLIN + 1, 2

St$ = "Sorting archive..."

PLACE 2, CSRLIN + 1, "box", St$, TextColor%

LOCATE CSRLIN + 1, 2

SortDub% = CSRLIN

DIM aStack(1 TO 1024) AS StackType

  StackPtr = 1
 
  aStack(StackPtr).low = 1
 
  aStack(StackPtr).hi = FileLines&
 
  StackPtr = StackPtr + 1
 
  DO
    StackPtr = StackPtr - 1
   
    low& = aStack(StackPtr).low
   
    hi& = aStack(StackPtr).hi
   
    DO
      i& = low&
     
      j& = hi&
     
      Mid& = (low& + hi&) \ 2
     
      'Want to see searching results? unremark below lines.
     
      'LOCATE 5, 1
     
      'PRINT "mid:"; Mid&; GetReeks$(Mid&)
      'PRINT "I:"; i&; GetReeks$(i&)
      'PRINT "J:"; j&; GetReeks$(j&)
     
      'SLEEP
     
      Compare$ = GetReeks$(Mid&)
     
      DO
       
        DO WHILE GetReeks$(i&) < Compare$
          i& = i& + 1
        LOOP
       
        DO WHILE GetReeks$(j&) > Compare$
          j& = j& - 1
        LOOP
       
        IF i& <= j& THEN
          Switch i&, j&
         
          i& = i& + 1
         
          j& = j& - 1
        END IF

      LOOP WHILE i& <= j&
     
      IF j& - low& < hi& - i& THEN
       
        IF i& < hi& THEN
         
          aStack(StackPtr).low = i&
         
          aStack(StackPtr).hi = hi&
         
          StackPtr = StackPtr + 1
        END IF
       
        hi& = j&
      ELSE
       
        IF low& < j& THEN
          aStack(StackPtr).low = low&
         
          aStack(StackPtr).hi = j&
         
          StackPtr = StackPtr + 1
        END IF
       
        low& = i&
      END IF
   
    LOOP WHILE low& < hi&
 
  LOOP WHILE StackPtr <> 1
END SUB

SUB LoadToXMS (InputFile$, NeededMemSize%)

  UploadFile% = FREEFILE
 
  SELECT CASE TempHandler%
   
    CASE IS = 1
      OPEN InputFile$ FOR INPUT AS #UploadFile%

      LOCATE CSRLIN + 1, 2

      St$ = "Loading main archive to XMS..."

      PLACE 2, CSRLIN + 1, "box", St$, TextColor%
     
      LOCATE CSRLIN + 1, 2
     
      DO WHILE NOT EOF(UploadFile%)
        LINE INPUT #UploadFile%, In$
   
        HadLen& = HadLen& + LEN(In$) + 2
     
        Percent% = CLNG(HadLen& / LOF(UploadFile%) * 100)

        Progress Percent%, 4

        LineNumber& = LineNumber& + 1
      
        PutReeks In$, LineNumber&

        TempError% = WhichXError%

        IF XMSError% THEN
          PRINT LineNumber&

          ShowXmsError TempError%
         
          PRINT ">"; GetReeks$(LineNumber&); "<"
         
          PRINT TempError%

          FreeHandles

          SCREEN 0

          CLOSE #UploadFile%

          Terminate
        END IF

      LOOP
   
      CLOSE #UploadFile%
     
      UploadFile% = 0

      Pbar% = 0
    CASE IS = 2
      OPEN InputFile$ FOR BINARY AS #UploadFile% LEN = 100

     
      LOCATE CSRLIN + 1, 2
     
      St$ = "Loading Database to XMS..."

      PLACE 2, CSRLIN + 1, "box", St$, TextColor%
    
      LOCATE CSRLIN + 1, 2
     
      DO WHILE NOT EOF(UploadFile%)
        In$ = STRING$(100, " ")
       
        GET #UploadFile%, LOC(UploadFile%) + 1, In$
  
        HadLen& = HadLen& + LEN(In$) + 2
    
        Percent% = CLNG(HadLen& / LOF(UploadFile%) * 100)

        Progress Percent%, 4

        LineNumber& = LineNumber& + 1
     
        In$ = In$ + "0"
       
        PutReeks In$, LineNumber&
       
        TempError% = WhichXError%

        IF WhichXError% > 0 THEN
          TempError% = WhichXError%
         
          FreeHandles

          SCREEN 0

          PRINT LineNumber&
         
          ShowXmsError TempError%

          CLOSE #UploadFile%

          Terminate
        END IF

      LOOP
  
      CLOSE #UploadFile%
    
      UploadFile% = 0
  
      Pbar% = 0
 
  END SELECT

END SUB

SUB PutReeks (Variabele$, Nummer&)

  ' This routine substitutes the [Array()] handlers of Quickbasic
  ' It set's an element into XMS-memory with a basic-string value.
  ' You can change this to your needs to let it insert other values than
  ' stringvalues.
 
  SELECT CASE TempHandler%
  
    CASE IS = 1
      File(1).FileLine = STRING$(Leng%, " ")

      File(1).FileLine = Variabele$

      CALL XSetElement(FileHandle%, File(1), Leng%, Nummer&)
     
    CASE IS = 2
      Dbase(1).DbaseLine = STRING$(Leng%, " ")
     
      Dbase(1).DbaseLine = Variabele$

      CALL XSetElement(DbaseHandle%, Dbase(1), 102, Nummer&)

    CASE ELSE
      PRINT "XMs handler not set!"
     
      END

  END SELECT
 
 
END SUB

SUB ShowXmsError (XmsXError%)
 
  SELECT CASE XmsXError%
    CASE 128
      PRINT "Unsupported XMS-function... exitting."
     
      Terminate

    CASE 129
      PRINT "Please deinstall your Virtual Diskmanager prior to using this program."
     
      PRINT "Exitting."
     
      Terminate

    CASE 130
      PRINT "A20 error occured."

      PRINT "Exitting."

      Terminate

    CASE 142
      PRINT "General Himem error."
      
      PRINT "Exitting."

      Terminate

    CASE 143
      PRINT "Fatal Himem error."
      
      PRINT "Exitting."

      Terminate

    CASE 144
      PRINT "HMA does not exist."

      PRINT "Exitting."

      Terminate

    CASE 145
      PRINT "HMA already in use."

      PRINT "Exitting."

      Terminate

    CASE 147
      PRINT "HMA not allocated."

      PRINT "Exitting."

      Terminate

    CASE 148
      PRINT "A20 still enabled."

      PRINT "Exitting."

      Terminate

    CASE 160
      PRINT "Not enough XMS memory.This program needs at least 2MB of memory."

      PRINT "Exitting."

      Terminate

    CASE 161
      PRINT "All handles are allocated."

      PRINT "Exitting."

      Terminate

    CASE 162
      PRINT "Invalid handle."

      PRINT "Exitting."

      Terminate

    CASE 163
      PRINT "Source handle invalid."

      PRINT "Exitting."

      Terminate

    CASE 164
      PRINT "Source offset invalid."

      PRINT "Exitting."

      Terminate

    CASE 165
      PRINT "Destination handle invalid."

      PRINT "Exitting."

      Terminate

    CASE 166
      PRINT "Destination offset invalid."

      PRINT "Exitting."

      Terminate

    CASE 167
      PRINT "Invalid length parameter."

      PRINT "Exitting."

      Terminate

    CASE 168
      PRINT "Move has invalid overlap."

      PRINT "Exitting."

      Terminate

    CASE 169
      PRINT "Parity error occured! Test your XMS simm-modules!"

      PRINT "Exitting."

      Terminate

    CASE 170
      PRINT "Block is not locked."

      PRINT "Exitting."

      Terminate

    CASE 171
      PRINT "Block is locked."

      PRINT "Exitting."

      Terminate

    CASE 172
      PRINT "Block lock count overflow."

      PRINT "Exitting."

      Terminate

    CASE 173
      PRINT "Lock failed."

      PRINT "Exitting."

      Terminate

    CASE 176
      PRINT "Only a smaller UMB is available."

      PRINT "Exitting."

      Terminate

    CASE 177
      PRINT "No UMB's are available."

      PRINT "Exitting."

      Terminate

    CASE 178
      PRINT "UMB segment is invalid."

      PRINT "Exitting."

      Terminate

  END SELECT
END SUB

SUB Switch (A&, B&)
 
  'This routine is the substitute of Basic's [SWAP] function.
  'It does the same with arrays and strings in XMS as Swap does in Basic.
  'You only work with the corresponding arrayelements this time.

  B$ = GetReeks$(B&)
 
  A$ = GetReeks$(A&)
 
  'I tried 'PutReeks GetReeks$(B&), A&' but that was not a wise decision i
  'made, it took me one day to find THAT bug that doubled up the lines.
  'I think that passing a Functionstring to a Subroutine causes trouble in
  'the first place. just don't adapt a trick like that avoid long debugging.

  PutReeks B$, A&
 
  PutReeks A$, B&

END SUB

